import numpy as np

import arithmetics
import lrsNash
import cfr
import exploitibility

if __name__ == "__main__":
    A = np.array([[13800, -36365, -18522],
                  [36700, 13800, -36200],
                  [18522, 36365, 13800]]) / 10000
    B = np.array([[29500, 10383, -33139],
                  [21600, 29500, 70700],
                  [33139, -10383, 29500]]) / 10000

    x0 = arithmetics.rand_f(1, 2).T
    y0 = arithmetics.rand_f(1, 2).T
    # x = np.array([[0.0000, 0.0690, 0.9310]]).T
    # y = np.array([[0.7334, 0.0000, 0.2666]]).T

    x, y = lrsNash.lrsNash(A, B)
    print("lrsNash:")
    print("x:", x)
    print("y:", y)
    print("")

    x, y = cfr.cfr(A, B, x0, y0, 500, Rx0=1, Ry0=1)
    print("CFR:")
    print("x:", x.T)
    print("y:", y.T)
    print("")

    x = x0
    y = y0
    ep_old2 = np.inf
    ep_old1 = np.inf
    ep = np.inf
    for t in range(32):
        print("t:", t, end=", ")
        print("ep:", ep, end=", ")
        print("x:", x.T, end=", ")
        print("y:", y.T)
        ep_old2 = ep_old1
        ep_old1 = ep
        x_, y_, ep = exploitibility.ep_downhill(A, B, x, y, 16, smoothmax_corner=0.01, dt=0.001)

        if ep < ep_old2 or ep < ep_old1:
            x, y = x_, y_
        else:
            break
